/* Datei: schlange.c                        */
/* zeitorientierte Warteschlangensimulation */

# include <stdio.h>
# include <stdlib.h>
# include <time.h>


/* System-Variablen */
long Zeit;                   /* aktuelle Simulationszeit                   */
long max_Zeit;               /* Anzahl der zu simulierenden Zeitschritte   */

/* Modell-Variablen */
int  Rest_Ankunft;           /* Restdauer bis Ankunft naechster Kunde      */
int  Rest_Bedienung;         /* Restdauer bis Ende Bedienung               */
long neuer_Kunde;            /* Nr. des Kunden, der in dieser Minute kam   */
long letzter_Kunde;          /* Nr. des letzten Kunden                     */
long bedienter_Kunde;        /* Nr. des gerade bedienten Kunden            */
int  Schlangenlaenge;        /* aktuelle Schlangenlaenge                   */

/* Auswerte-Variablen */
long Summe_Bedienung;        /* Anzahl der Minuten, in denen bedient wurde */
long Summe_Schlangenlaenge;  /* Summe aller Schlangenlaengen               */


void initialisierung ()
  {
    randomize ();

    Schlangenlaenge = 0;
    letzter_Kunde   = 0;
    bedienter_Kunde = 0;

    Rest_Bedienung  = 0;
    Rest_Ankunft    = 2;

    Summe_Bedienung       = 0;
    Summe_Schlangenlaenge = 0;

    printf ("\n\n");
    printf ("        neuer bedienter   Laenge\n");
    printf ("Minute  Kunde     Kunde Schlange\n");
    printf ("------ ------ --------- --------\n");
  }


void berechnung ()
  {
    /* Ankunft naechster Kunde? */
    Rest_Ankunft = Rest_Ankunft - 1;
    if (Rest_Ankunft == 0)
	{ /* neuer Kunde kommt an */
	  letzter_Kunde   = letzter_Kunde + 1;
	  neuer_Kunde     = letzter_Kunde;
	  Schlangenlaenge = Schlangenlaenge + 1;
	  Rest_Ankunft    = 1 + random(5); /* = 1..5 */
	}
      else
	neuer_Kunde = 0;

    /* aktuelle Kunden weiter bedienen sofern vorhanden */
    if (bedienter_Kunde > 0)
      {
	Rest_Bedienung = Rest_Bedienung - 1;
	if (Rest_Bedienung == 0)
	  { /* Bedienung beendet; Kunde verlaesst Schlange */
	    bedienter_Kunde = 0;
	    Schlangenlaenge = Schlangenlaenge - 1;
	  }
      }

    /* naechsten Kunden bedienen? */
    if ((bedienter_Kunde == 0) && (Schlangenlaenge > 0))
      { /* ersten Kunden der Schlange bedienen */
	bedienter_Kunde = letzter_Kunde - Schlangenlaenge + 1;
	Rest_Bedienung  = 1 + random(4); /* = 1..4 */
      }

    /* Summen fuer statistische Auswertung */
    if (bedienter_Kunde > 0)
      Summe_Bedienung = Summe_Bedienung + 1;
    Summe_Schlangenlaenge = Summe_Schlangenlaenge + Schlangenlaenge;

    /* Ausgabe des aktuellen Status */
    printf ("%6ld %6ld %9ld %8d\n", Zeit, neuer_Kunde, bedienter_Kunde, Schlangenlaenge);
  }


void ergebnis_ausgabe ()
  {
    printf ("\n");
    printf ("Zeitdauer:  %d Min.\n", Zeit);
    printf ("Kundenzahl: %d\n", letzter_Kunde);
    printf ("\n");
    printf ("Auslastung Bedienperson:   %.1f\n",
	    (Summe_Bedienung*100.0/Zeit));
    printf ("mittlere Schlangenlaenge:  %.1f\n",
	    (Summe_Schlangenlaenge*1.0/Zeit));
    printf ("mittlere Aufenthaltsdauer: %.1f\n",
	    (Summe_Schlangenlaenge*1.0/letzter_Kunde));
  }


void main ()
  {
    printf ("Anzahl Minuten: ");
    scanf ("%ld", &max_Zeit);

    initialisierung ();

    Zeit = 0;
    do
      {
	Zeit = Zeit + 1;
	berechnung ();
      }
    while (Zeit < max_Zeit);

    ergebnis_ausgabe ();
  }