// Datei: zg_test.cpp
// Testprogramm fuer Zufallsgenerator

# include <stdio.h>
# include <math.h>
# include "e:\compiler\tcwin\prog\zgen.cpp"

void main ()
  {
    double Startklasse   = -2.5; // untere Grenze der 1. Klasse
    double Klassenbreite = 0.25;
    int    Klassenzahl   = 20;   // + zwei offene Randklassen
    long   n = 10000;            // Stichprobenumfang

    long   Klasse[100];
    long   max_Anzahl = 0;       // Haeufigkeit in staerkster Klasse
    double Summe_X    = 0.0;     // fuer statistische Auswertung
    double Summe_XX   = 0.0;
    double z;
    long   i, j;
    int    k;
    Zufallsgenerator zgen (40629, 2147483399);
    double feld[10] = {0.1, 0.2, 0.3, 0.5, 1.0};

    // Klassen auf 0 initialisieren
    for (i=0; i<=Klassenzahl+1; i=i+1)
      Klasse[i] = 0;

    // Zufallsstichprobe in Klassen einordnen
    for (i=1; i<=n; i=i+1)
      {
        z = zgen.standardnormalverteilt();
        // z = zgen.normalverteilt(1.0, 4.0);
        // z = zgen.exponentialverteilt(1.0/3.0);
        // z = zgen.gleichverteilt(1, 8);
        // z = zgen.gleichverteilt(1.0, 8.0);
	// z = zgen.tabellenverteilt(feld);

        Summe_X = Summe_X + z;
        Summe_XX = Summe_XX + (z*z);

        k = 1 + (int)((z - Startklasse) / Klassenbreite);
        if (k < 0)
          k = 0;
        if (k > Klassenzahl)
          k = Klassenzahl + 1;
        Klasse[k] = Klasse[k] + 1;
      }

    // groesste Klassenstaerke ermitteln
    for (i=0; i<=Klassenzahl+1; i=i+1)
      if (Klasse[i] > max_Anzahl)
        max_Anzahl = Klasse[i];

    // Ergebnis ausgeben
    printf ("Klassengrenzen     Anzahl  ");
    printf ("E(X) = %.3lf  StdAbw(X) = %.3lf\n",
            Summe_X/n,
            sqrt(Summe_XX/n - (Summe_X*Summe_X/(n*n))));
    printf ("----------------   ------  \n");
    for (i=0; i<=Klassenzahl+1; i=i+1)
      {
        // Klassengrenzen angeben
        if (i == 0)
          printf ("       < %6.2lf ", Startklasse);
        else if (i > Klassenzahl)
          printf ("      <= %6.2lf ",
                  Startklasse + Klassenzahl*Klassenbreite);
        else
          printf ("[%6.2lf; %6.2lf)",
                  Startklasse + (i-1)*Klassenbreite,
                  Startklasse +     i*Klassenbreite);

        // absolute Anzahl in Klasse
        printf (" %8ld  ", Klasse[i]);

        // Histogramm-Ausgabe
        for (j=1; j<=Klasse[i]*30.0/max_Anzahl; j=j+1)
          printf ("*");
        printf ("\n");
      }
  }